/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rdm.fronting.server.web.ui.internal.wizard.WizardMigrationReview");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("jazz.app.auth");
dojo.require("jazz.ui.Button");
dojo.require("com.ibm.team.repository.web.ui.wizard.WizardStepHeader");
dojo.require("com.ibm.team.repository.web.ui.wizard.WizardStep");

dojo.require("dojo.i18n");
dojo.requireLocalization("com.ibm.rdm.fronting.server.web.ui.internal.wizard", "WizardMessages");

dojo.require("com.ibm.rdm.fronting.server.web.util.rrsutils");

(function() {
var rrsutils = com.ibm.rdm.fronting.server.web.util.rrsutils;
var messages;
var WizardStepHeader = com.ibm.team.repository.web.ui.wizard.WizardStepHeader;
var WizardStep = com.ibm.team.repository.web.ui.wizard.WizardStep;
var success = false;

dojo.declare("com.ibm.rdm.fronting.server.web.ui.internal.wizard.WizardMigrationReview", [WizardStep, dijit._Widget, dijit._Templated], {

	templatePath: dojo.moduleUrl("com.ibm.rdm.fronting.server.web", "ui/internal/wizard/templates/Review.html"),
	
	constructor: function() {
		this.messages = messages = dojo.i18n.getLocalization("com.ibm.rdm.fronting.server.web.ui.internal.wizard", "WizardMessages");
		this.stepTitle = messages.stepMigrationReviewTitle;
	},
	
	postCreate: function(){
		var header = new WizardStepHeader({
			stepTitle: this.stepTitle
		});
		this.stepHeaderArea.appendChild(header.domNode);
	},

	focusStep: function () {
		//do a POST to /migration service with query params
		var rrsUrl = rrsutils.getRRSUrl(document.location.href);
	
		var qstr = window.location.search.substr(1);

		var responseNode = this.responseMessage;
		
		var result = jazz.client.xhrPost({
	  		url: rrsUrl + "/migration?" + qstr,
	  		load: function(data, ioargs){
	  		  	var finished = false;
	  		  	while (finished == false) {
	  		  		//check the status of the migration
	  		  		var result = jazz.client.xhrGet({
						url: rrsUrl + "/migration?status",
						sync: true,
						headers: {
			                "Accept": "application/json"
			            },
						load: function(data, ioargs){
      						var json = eval('(' + data + ')');
							responseNode.innerHTML = parseData(json);
							if (json.remainingTasks == 0) {
								finished = true;
							}
						},
						error: function(error){
							responseNode.innerHTML = error;
							finished = true;
						}	        
					});
				}
	        },
	        error: function(error){
	          	responseNode.innerHTML = error;
	        }	        
	  	});
		
		this.success = true;
	},
	
	canFinish: function() {
		return this.success;
	}		
});
function parseData (json) {

	var buf = "";

	// heading
	buf = buf + "<h3>";
	if (json.remainingTasks == 0) {
		if(typeof(json.errors) != "undefined") {
			buf = buf + messages.Migration_Failed;
		} else {
			buf = buf + messages.Migration_Completed;
		}
	} else {
		buf = buf + messages.Migration_Running;
	}
	buf = buf + "</h3>";
	
	buf = buf + "<br>";
	
	//errors
	if(typeof(json.errors) != "undefined") {
		for (var i = 0; i < json.errors.length; i++) {
			buf = buf + json.errors[i];
			buf = buf + "<br>";
		}
		buf = buf + "<br>";
	}
	
	//results
	for (var i = 0; i < json.results.length; i++) {
		buf = buf + json.results[i];
		buf = buf + "<br>";
	}
	
	return buf;//"Hi<br>";
}
})();